Debian Bug report logs - #571640
debhelper: qmake build system can't be set to use qmake-qt3 or qmake-qt4

version graph

Package: debhelper; Maintainer for debhelper is Debhelper Maintainers <debhelper-devel@lists.alioth.debian.org>; Source for debhelper is src:debhelper.

Reported by: Michael Karcher <debian@mkarcher.dialup.fu-berlin.de>

Date: Fri, 26 Feb 2010 17:33:01 UTC

Severity: normal

Found in version debhelper/7.4.13

Done: Joey Hess <joeyh@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#571640; Package debhelper. (Fri, 26 Feb 2010 17:33:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Karcher <debian@mkarcher.dialup.fu-berlin.de>:
New Bug report received and forwarded. Copy sent to Joey Hess <joeyh@debian.org>. (Fri, 26 Feb 2010 17:33:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Michael Karcher <debian@mkarcher.dialup.fu-berlin.de>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Cc: glaubitz@physik.fu-berlin.de
Subject: debhelper: qmake build system can't be set to use qmake-qt3 or qmake-qt4
Date: Fri, 26 Feb 2010 18:31:21 +0100
Package: debhelper
Version: 7.4.13
Severity: normal

The qmake build system in debhelper calls qmake, which, dependent on
installed packages, is either Qt 3 or the Qt 4 version. If both Qt versions
are installed, qmake defaults to qmake-qt3 (priority 45) over qmake-qt4
(priority 40), making the automatic build system unable to build Qt 4
packages.

An option to choose either qmake-qt3 or qmake-qt4, or even hard
wiring qmake-qt4 as the automatic build system is mainly used for new
packages that mainly use qt4 would be nice, IMHO.

Regards,
  Michael Karcher

-- System Information:
Debian Release: squeeze/sid
  APT prefers testing
  APT policy: (500, 'testing')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.32-trunk-amd64 (SMP w/4 CPU cores)
Locale: LANG=de_DE.UTF-8, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages debhelper depends on:
ii  binutils                      2.20-6     The GNU assembler, linker and bina
ii  dpkg-dev                      1.15.5.6   Debian package development tools
ii  file                          5.04-1     Determines file type using "magic"
ii  html2text                     1.3.2a-14  advanced HTML to text converter
ii  man-db                        2.5.6-5    on-line manual pager
ii  perl                          5.10.1-11  Larry Wall's Practical Extraction 
ii  perl-base                     5.10.1-11  minimal Perl system
ii  po-debconf                    1.0.16     tool for managing templates file t

debhelper recommends no packages.

Versions of packages debhelper suggests:
ii  dh-make                       0.51       tool that converts source archives

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#571640; Package debhelper. (Mon, 01 Mar 2010 22:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kel Modderman <kel@otaku42.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Mon, 01 Mar 2010 22:06:03 GMT) Full text and rfc822 format available.

Message #10 received at 571640@bugs.debian.org (full text, mbox):

From: Kel Modderman <kel@otaku42.de>
To: Michael Karcher <debian@mkarcher.dialup.fu-berlin.de>, glaubitz@physik.fu-berlin.de
Cc: 571640@bugs.debian.org
Subject: Re: debhelper: qmake build system can't be set to use qmake-qt3 or qmake-qt4
Date: Tue, 2 Mar 2010 07:44:43 +1000
On Saturday 27 February 2010 03:31:21 Michael Karcher wrote:
> Package: debhelper
> Version: 7.4.13
> Severity: normal
> 
> The qmake build system in debhelper calls qmake, which, dependent on
> installed packages, is either Qt 3 or the Qt 4 version. If both Qt versions
> are installed, qmake defaults to qmake-qt3 (priority 45) over qmake-qt4
> (priority 40), making the automatic build system unable to build Qt 4
> packages.

In the future, these build systems may be able to handle their own specific
options. This build system could accept a --qmake option which sets the
qmake binary to be called.

For now you can use Build-Conflicts, but thats not as convenient.

> 
> An option to choose either qmake-qt3 or qmake-qt4, or even hard
> wiring qmake-qt4 as the automatic build system is mainly used for new
> packages that mainly use qt4 would be nice, IMHO.

Hardcoding anything would be crap.

Thanks, Kel.




Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#571640; Package debhelper. (Mon, 01 Mar 2010 22:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Karcher <debian@mkarcher.dialup.fu-berlin.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Mon, 01 Mar 2010 22:39:03 GMT) Full text and rfc822 format available.

Message #15 received at 571640@bugs.debian.org (full text, mbox):

From: Michael Karcher <debian@mkarcher.dialup.fu-berlin.de>
To: Kel Modderman <kel@otaku42.de>
Cc: glaubitz@physik.fu-berlin.de, 571640@bugs.debian.org
Subject: Re: debhelper: qmake build system can't be set to use qmake-qt3 or qmake-qt4
Date: Mon, 01 Mar 2010 23:37:44 +0100
Am Dienstag, den 02.03.2010, 07:44 +1000 schrieb Kel Modderman:
> > The qmake build system in debhelper calls qmake, which, dependent on
> > installed packages, is either Qt 3 or the Qt 4 version. If both Qt versions
> > are installed, qmake defaults to qmake-qt3 (priority 45) over qmake-qt4
> > (priority 40), making the automatic build system unable to build Qt 4
> > packages.
> In the future, these build systems may be able to handle their own specific
> options. This build system could accept a --qmake option which sets the
> qmake binary to be called.
That sounds like a good idea.

> > An option to choose either qmake-qt3 or qmake-qt4, or even hard
> > wiring qmake-qt4 as the automatic build system is mainly used for new
> > packages that mainly use qt4 would be nice, IMHO.
> Hardcoding anything would be crap.
Which also applies to "qmake" (as it is now) as well. "qmake-qt4" is at
least consistent on all Debian Systems, without needing a
Build-Conflicts on Qt3's qmake.

Thanks for your response to the bug report,
  Michael Karcher





Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#571640; Package debhelper. (Tue, 02 Mar 2010 10:24:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kel Modderman <kel@otaku42.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Tue, 02 Mar 2010 10:24:02 GMT) Full text and rfc822 format available.

Message #20 received at 571640@bugs.debian.org (full text, mbox):

From: Kel Modderman <kel@otaku42.de>
To: Michael Karcher <debian@mkarcher.dialup.fu-berlin.de>
Cc: glaubitz@physik.fu-berlin.de, 571640@bugs.debian.org
Subject: Re: debhelper: qmake build system can't be set to use qmake-qt3 or qmake-qt4
Date: Tue, 2 Mar 2010 20:22:10 +1000
On Tuesday 02 March 2010 08:37:44 Michael Karcher wrote:
> Am Dienstag, den 02.03.2010, 07:44 +1000 schrieb Kel Modderman:
> > > The qmake build system in debhelper calls qmake, which, dependent on
> > > installed packages, is either Qt 3 or the Qt 4 version. If both Qt versions
> > > are installed, qmake defaults to qmake-qt3 (priority 45) over qmake-qt4
> > > (priority 40), making the automatic build system unable to build Qt 4
> > > packages.
> > In the future, these build systems may be able to handle their own specific
> > options. This build system could accept a --qmake option which sets the
> > qmake binary to be called.
> That sounds like a good idea.
> 
> > > An option to choose either qmake-qt3 or qmake-qt4, or even hard
> > > wiring qmake-qt4 as the automatic build system is mainly used for new
> > > packages that mainly use qt4 would be nice, IMHO.
> > Hardcoding anything would be crap.
> Which also applies to "qmake" (as it is now) as well. "qmake-qt4" is at
> least consistent on all Debian Systems, without needing a
> Build-Conflicts on Qt3's qmake.

Nah, I think 'qmake' is the best we can do right now. It works in a clean
chroot (and can be made more robust with build-conflicts, but thats a pain
for a host system) and allows to take advantage of benefits of honouring
noopt, nostrip DEB_BUILD_OPTIONS, being able to easily override LDFLAGS
and so on, which is what I wanted to do with my couple of measly qt
packages.

There is no way that I know of to detect if source files of qt projects
require qt3 or qt4.

Thanks, Kel.




Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#571640; Package debhelper. (Sun, 25 Apr 2010 10:27:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to fabo@debian.org:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Sun, 25 Apr 2010 10:27:02 GMT) Full text and rfc822 format available.

Message #25 received at 571640@bugs.debian.org (full text, mbox):

From: Fathi Boudra <fabo@debian.org>
To: 571640@bugs.debian.org
Subject: qmake buildsystem improvement: versioned qmake binary
Date: Sun, 25 Apr 2010 13:23:37 +0300
Hi,

it should set QMAKE environment variable to qmake binary used.

Cheers,

Fathi




Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#571640; Package debhelper. (Wed, 19 Jan 2011 22:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raúl Sánchez Siles <rasasi78@gmail.com>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Wed, 19 Jan 2011 22:21:05 GMT) Full text and rfc822 format available.

Message #30 received at 571640@bugs.debian.org (full text, mbox):

From: Raúl Sánchez Siles <rasasi78@gmail.com>
To: 571640@bugs.debian.org
Subject: Any news?
Date: Wed, 19 Jan 2011 23:20:11 +0100
[Message part 1 (text/plain, inline)]
  Hello:

  I've also bump on this issue, is there any news/plan about it?

  Thanks.

-- 
     Raúl Sánchez Siles
----->Proud Debian user<-----
Linux registered user #416098
[signature.asc (application/pgp-signature, inline)]

Message sent on to Michael Karcher <debian@mkarcher.dialup.fu-berlin.de>:
Bug#571640. (Thu, 07 Apr 2011 14:51:19 GMT) Full text and rfc822 format available.

Message #33 received at 571640-submitter@bugs.debian.org (full text, mbox):

From: Scott Howard <showard314@gmail.com>
To: 571640-submitter@bugs.debian.org, 571640-subscribe@bugs.debian.org
Cc: debian-qt-kde@lists.debian.org
Subject: Switch qmake-qt3 and qmake-qt4 priorities?
Date: Thu, 7 Apr 2011 10:44:51 -0400
In reference to bug 571640:

>The qmake build system in debhelper calls qmake, which, dependent on
>installed packages, is either Qt 3 or the Qt 4 version. If both Qt versions
>are installed, qmake defaults to qmake-qt3 (priority 45) over qmake-qt4
>(priority 40), making the automatic build system unable to build Qt 4
>packages.

Since qt3 is on it's way out of the archives, would it make sense to
just switch the priorities of the two qmakes in sid until it is
removed? Give qmake-qt4 priority 45 and qmake-qt3 priority 40?

Cheers,
Scott




Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#571640; Package debhelper. (Wed, 01 Jun 2011 11:36:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to barak@cs.nuim.ie:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Wed, 01 Jun 2011 11:36:04 GMT) Full text and rfc822 format available.

Message #38 received at 571640@bugs.debian.org (full text, mbox):

From: "Barak A. Pearlmutter" <barak@cs.nuim.ie>
To: 571640@bugs.debian.org
Subject: automatic qmake-qtX detection
Date: Wed, 01 Jun 2011 12:26:22 +0100
> There is no way that I know of to detect if source files of qt
> projects require qt3 or qt4.

There may be no completely foolproof way, but it's pretty easy to make
a good guess.

How about, if both qmake-qt3 and qmake-qt4 are available, use
qmake-qt4 if the string qt4 is present in the build dependencies, if
not then use qmake-qt3 if the string qt3 is present, otherwise just
use plain qmake.

This might not be particularly robust, but would work about 98.6% of
the time, would require no changes in the packaging info but only in
debhelper, and is simple and easy to implement and explain.

(Another alternative would be to grovel through the sources for the
strings qt3 and qt4 and take some sort of vote

  $ git grep qt4 -- '*.cbp' | wc -l

  11

  $ git grep qt3 | wc -l

  0

but that would be hideous.)

					--Barak.
--
Barak A. Pearlmutter
 Hamilton Institute & Dept Comp Sci, NUI Maynooth, Co. Kildare, Ireland
 http://www.bcl.hamilton.ie/~barak/




Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#571640; Package debhelper. (Tue, 29 May 2012 00:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to chrysn <chrysn@fsfe.org>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Tue, 29 May 2012 00:54:03 GMT) Full text and rfc822 format available.

Message #43 received at 571640@bugs.debian.org (full text, mbox):

From: chrysn <chrysn@fsfe.org>
To: 571640@bugs.debian.org
Cc: control@bugs.debian.org
Subject: fixed since 8.9.1?
Date: Tue, 29 May 2012 02:42:40 +0200
[Message part 1 (text/plain, inline)]
the debhelper changelog for 8.9.1 states that

   * Now the QT4 version of qmake can be explicitly selected by passing
        --buildsystem=qmake_qt4. Closes: #566840

that bug was about adding qmake to debhelper, and already contained
suggestions for the issue of choosing a version (they used
--qmake=qmake-qt3), but the syntax described in the changelog entry was
not mentioned there.

i just tested the --buildsystem=qmake_qt4 parameter (in a backporting
environment where build-conflicts was not an option for dependency
reasons), and it solved the problems.

therefore, i suggest that this bug report be closed.
[signature.asc (application/pgp-signature, inline)]

Reply sent to Joey Hess <joeyh@debian.org>:
You have taken responsibility. (Tue, 29 May 2012 01:09:03 GMT) Full text and rfc822 format available.

Notification sent to Michael Karcher <debian@mkarcher.dialup.fu-berlin.de>:
Bug acknowledged by developer. (Tue, 29 May 2012 01:09:03 GMT) Full text and rfc822 format available.

Message #48 received at 571640-done@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: chrysn <chrysn@fsfe.org>, 571640-done@bugs.debian.org
Subject: Re: Bug#571640: fixed since 8.9.1?
Date: Mon, 28 May 2012 21:06:17 -0400
[Message part 1 (text/plain, inline)]
chrysn wrote:
> therefore, i suggest that this bug report be closed.

Fair enough.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 26 Jun 2012 07:38:57 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 24 02:15:33 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.